"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var Symbols_1 = require("../../Symbols");

var TokenClass_1 = require("../../TokenClass");

function continueStatementHandler(node) {
  return function () {
    return node.label ? new TokenClass_1.ContinueLabel(node.label.name) : Symbols_1.Continue;
  };
}

exports.continueStatementHandler = continueStatementHandler;