"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var util_1 = require("../../../util");

var TokenClass_1 = require("../../TokenClass"); // return xx;


function returnStatementHandler(node) {
  var argumentClosure = node.argument ? this.createClosure(node.argument) : util_1.noop;
  return function () {
    return new TokenClass_1.Return(argumentClosure());
  };
}

exports.returnStatementHandler = returnStatementHandler;