"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var main_1 = require("./interpreter/main");

exports.Interpreter = main_1.Interpreter;
exports.Parser = main_1.MyParser;

var vm = require("./vm");

exports.vm = vm;

var evaluate_1 = require("./evaluate");

exports.evaluate = evaluate_1.default;

var Function_1 = require("./Function");

exports.Function = Function_1.default;

var findglobal_1 = require("./util/findglobal");

exports.findGlobal = findglobal_1.default;