"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

function defineFunctionName(func, name) {
  Object.defineProperty(func, "name", {
    value: name,
    writable: false,
    enumerable: false,
    configurable: true
  });
}

exports.defineFunctionName = defineFunctionName;

function isFunction(func) {
  return typeof func === "function";
}

exports.isFunction = isFunction;

function noop() {}

exports.noop = noop;