"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Message_1 = require("../../Message");
// <App className="hello" />
// <App className={name} />
// <App show />
function JSXAttributeHandler(node) {
    if (node.name.type == 'JSXNamespacedName') {
        throw this.createInternalThrowError(Message_1.Messages.NormalError, 'JSXNamespacedName not support ', node);
    }
    var name = node.name.name;
    var valueClosure;
    if (!node.value) {
        valueClosure = function () { return true; };
    }
    else if (node.value.type == 'JSXFragment') {
        throw this.createInternalThrowError(Message_1.Messages.NormalError, 'JSXFragment not support!', node);
    }
    else {
        valueClosure = this.createClosure(node.value);
    }
    return function () {
        var _a;
        return _a = {},
            _a[name] = valueClosure(),
            _a;
    };
}
exports.JSXAttributeHandler = JSXAttributeHandler;
