"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Message_1 = require("../../Message");
// (...args)
function spreadElementHandler(node) {
    var _this = this;
    var closure = this.createClosure(node.argument);
    return function () {
        var data = closure();
        var MArray = _this.globalScope.data['Array'];
        if (!Array.isArray(data)) {
            throw _this.createInternalThrowError(Message_1.Messages.NormalError, "spread node type not array", node);
        }
        return data;
    };
}
exports.spreadElementHandler = spreadElementHandler;
