"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
}); // var1,var2,...

function sequenceExpressionHandler(node) {
  var _this = this;

  var expressions = node.expressions.map(function (item) {
    return _this.createClosure(item);
  });
  return function () {
    var result;
    var len = expressions.length;

    for (var i = 0; i < len; i++) {
      var expression = expressions[i];
      result = expression();
    }

    return result;
  };
}

exports.sequenceExpressionHandler = sequenceExpressionHandler;