"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var Symbols_1 = require("../../Symbols");

var TokenClass_1 = require("../../TokenClass");

function breakStatementHandler(node) {
  return function () {
    return node.label ? new TokenClass_1.BreakLabel(node.label.name) : Symbols_1.Break;
  };
}

exports.breakStatementHandler = breakStatementHandler;