"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
// <hello /> -> JSXIdentifier: hello
function JSXIdentifierHandler(node) {
    var closure = this.createClosure({
        type: "Identifier",
        name: node.name,
        loc: node.loc,
        // @ts-ignore
        start: node.start,
        // @ts-ignore
        end: node.end,
    });
    return function () {
        return closure();
    };
}
exports.JSXIdentifierHandler = JSXIdentifierHandler;
