"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
// var1 ...
function identifierHandler(node) {
    var _this = this;
    return function () {
        var currentScope = _this.getCurrentScope();
        var data = _this.getScopeDataFromName(node.name, currentScope);
        _this.assertVariable(data, node.name, node);
        return data[node.name];
    };
}
exports.identifierHandler = identifierHandler;
