"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
// 1 'name'
function literalHandler(node) {
    return function () {
        if (node.regex) {
            return new RegExp(node.regex.pattern, node.regex.flags);
        }
        return node.value;
    };
}
exports.literalHandler = literalHandler;
